/*
Copyright 2012 Arun Kumar and Christopher Re

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

This work was supported by the Microsoft Jim Gray Systems Lab, 
the National Science Foundation and the Office of Naval Research.
*/
#ifndef INDEXGENUTILS_H
#define INDEXGENUTILS_H

#include <iostream>
#include <fstream>
#include <string>
#include <cstring>
#include <sstream>
#include <vector>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <sys/time.h>
#include <cmath>
using namespace std;

//the alphabet size is 94 - 32 to 125 chars -> updated to 126 - 0 to 125
#define NUMCHAR 126

typedef pair <int, pair <int, int> > location;	//blkno, pathno, offset
typedef map <int, set <location> > augstates;	//the dfa cna be in state x after blk b, and the augmentations for this are in a set; each invocn of recemit on a block takes in a set of "augmented states" -> states with locn info and returns the same

string toLower(string inp);
void fwdDFS(int *preftrie, map <int, string> *finals, int curst, string curstr);
inline set < pair <int, int> > getNextStateoffs(set < pair <int, int> > *stateoffs, int *preftrie, char ch);
augstates recEmit(map <int, vector <string> > *allpaths, map <int, vector <int> > *revgph, int *preftrie, map <int, string> *finals,  int thisblk, augstates *memoaugstates, int *memoflag, augstates *emissions, int *numchildren, int *visitcount);

#endif
