/*
Copyright 2012 Arun Kumar and Christopher Re

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

This work was supported by the Microsoft Jim Gray Systems Lab, 
the National Science Foundation and the Office of Naval Research.
*/
#include "libraries/fstUtils.h"
#include <fstream>
int main(int argc,char **argv) {
	if(argc < 4) {
		cout << "Usage: kmapgen <.mbin file> <numPaths> <.kmap file>\n";
		return 0;
	}
	int numPaths = atoi(argv[2]);
	ifstream finmbin(argv[1], ios::in|ios::binary);
	ofstream foutkmap(argv[3], ios::out);
	StdVectorFst *ifst = new StdVectorFst;
	mbintofst(ifst, finmbin);
	int numnodes = getNumNodesFst(ifst);
	if(numnodes < 2) {
		cout << "Error: Fst is too small!\n";
		exit(1);
	}
	PathIterator incrementalN;
	constructIterator(&incrementalN, ifst);
	for(int j=0;j<numPaths;j++)	{
		Path p = incrementalN.getNext();
		if(incrementalN.moreflag == 0)	//no more paths
			break;
		foutkmap << p.getPathStr() << "\t:\t" << p.getPathCost() << endl;
	}
	delete incrementalN.enumerator;
return 0;
}
